# Runify
# by Eresse <eresse@eresse.net>

# External Includes
require 'thread'

# Internal Includes
require 'runify/version'

# Runify Module:
# Root Module for Runify.
module Runify

	# Startup:
	# Spawns a new Thread around the _run_ method.
	def startup
		return if defined?(@thread) && @thread
		@stop = nil
		@thread = Thread.new { run }
	end

	# Shutdown:
	# Requests the _run_ method to complete and blocks until it returns.
	def shutdown
		@stop = true
		@thread.join if defined?(@thread) && @thread
		@thread = nil
	end

	# Restart:
	# Calls _shutdown_, immediately followed by _startup_.
	def restart
		shutdown
		startup
	end
end
